<?php

include_once(SM_PATH . 'plugins/fg_spamassassin/config.php');

//------------------------------------------------------------------------
function load_spamassassin($username)
{
	if (SA_USE_MYSQL == TRUE)
		load_spamassassin_mysql($username);
	else
		load_spamassassin_file($username);
}


function load_spamassassin_mysql($username)
{
	global $sa;
	global $sac;
	global $sabl;
	global $sawl;
	global $saloaded;

	if ($saloaded) return;
	$saloaded++;

	$sa["defang_mime"] = 0;
	$sa["required_hits"] = 5;
	$sa["report_header"] = 0;
	$sa["use_terse_report"] = 1;
	$sa["procmail_enabled"] = 1;
	$sa["procmail_delete"] = 0;
	$sa["advanced"] = 0;
	$sa['skip_rbl_checks'] = 0;
	$sa['use_dcc'] = 1;
	$sa['use_razor2'] = 1;
	$sa['ok_languages'] = "all";
	$sa['bayes_auto_learn'] = "1";		// SA default now
	$sa['rewrite_header_subject'] = 0;
	$sa['rewrite_header_subject_tag'] = "[SPAM _HITS_]";
	$sa['use_auto_whitelist'] = 1;		// SA default now

	if (!mysql_connect(SA_DB_HOST,SA_DB_USER,SA_DB_PASS))
		die("mysql_connect: ". mysql_error());
	if (!mysql_select_db(SA_DB_DATABASE))
		die("mysql_select_db: ". mysql_error());

	$mysql = mysql_query("SELECT preference,value ".
		"FROM ". SA_DB_TABLE ." WHERE username='".
		$username ."' ORDER BY preference");
	if (mysql_errno() != 0) die("mysql_query: ". mysql_error());
	$num_rows = mysql_num_rows($mysql);

	if ($num_rows > 0)
	{
		for ($x=0; $x<$num_rows; $x++)
		{
			list($token,$value) = mysql_fetch_row($mysql);
			switch ($token)
			{
				case "whitelist_from" :
					$sawl[$value]=1;
					break;
				case "blacklist_from" :
					$sabl[$value]=1;
					break;
				case "score" :
					list($s,$v) = split(' ',$value,2);
					$sac[$s]=$v;
					break;
// For easy transition from SA 2.x to 3.x - will be removed at some point
				case "rewrite_subject" :
					$sa["rewrite_header_subject"] = $value;
					break;
// For easy transition from SA 2.x to 3.x - will be removed at some point
				case "subject_tag" :
					$sa["rewrite_header_subject_tag"] = $value;
					break;
				case "rewrite_header" :
					if (preg_match("/^Subject (.*)$/",
						$value,$header_matches))
					{
						$sa["rewrite_header_subject"] = 1;
						$sa["rewrite_header_subject_tag"] = $header_matches[1];
					}
					else
					{
						$sa[$token]=$value;
					}
					break;
				default :
					$sa[$token]=$value;
					break;
			}
		}
	}
	else
	{
		$sabl['porn@example.com'] = 1;
	}

	mysql_close();
}


function load_spamassassin_file($username)
{
	global $sa_spamassassin_name;
	global $sa;
	global $sac;
	global $sabl;
	global $sawl;
	global $saloaded;
	$sa_spamassassin_name = "../../data/$username.spamassassin";

	if ($saloaded) return;
	$saloaded++;

	$sa["defang_mime"] = 0;
	$sa["required_hits"] = 5;
	$sa["report_header"] = 0;
	$sa["use_terse_report"] = 1;
	$sa["procmail_enabled"] = 1;
	$sa["procmail_delete"] = 0;
	$sa["advanced"] = 0;
	$sa['skip_rbl_checks'] = 0;
	$sa['use_dcc'] = 1;
	$sa['use_razor2'] = 1;
	$sa['ok_languages'] = "all";
	$sa['bayes_auto_learn'] = "1";		// SA default now
	$sa['rewrite_header_subject'] = 0;
	$sa['rewrite_header_subject_tag'] = "[SPAM _HITS_]";


      if (file_exists($sa_spamassassin_name)) {
       $safp = fopen($sa_spamassassin_name,"r");
       while(!feof($safp)) {
         $line = fgets($safp,1024);
         $line = preg_replace('/#.*/','',$line);
         $line = preg_replace('/^\s+/','',$line);
         $line = preg_replace('/\s+$/','',$line);
         $line = preg_replace('/\s+/',' ',$line);
         if (strlen($line) < 1) continue;
         list($token,$value) = split(' ',$line,2);
         if (strlen($value) < 1) continue;
         if ($token == "whitelist_from") {
            $sawl[$value]=1;
         } else if ($token == "blacklist_from") {
            $sabl[$value]=1;
         } else if ($token == "score") {
            list ($s,$v) = split(' ',$value,2);
            $sac[$s]=$v;
         } else if ($token == "rewrite_subject") {
// For easy transition from SA 2.x to 3.x - will be removed at some point
		$sa["rewrite_header_subject"] = $value;
         } else if ($token == "subject_tag") {
// For easy transition from SA 2.x to 3.x - will be removed at some point
		$sa["rewrite_header_subject_tag"] = $value;
         } else if ($token == "rewrite_header") {
					if (preg_match("/^Subject (.*)$/",
						$value,$header_matches))
					{
						$sa["rewrite_header_subject"] = 1;
						$sa["rewrite_header_subject_tag"] = $header_matches[1];
					}
					else
					{
						$sa[$token]=$value;
					}
         } else {
            $sa[$token]=$value;
         }
       }
       fclose($safp);
      } else {
	$sabl['porn@example.com'] = 1;
      }   
}


//------------------------------------------------------------------------
function save_spamassassin($username)
{
	if (SA_USE_MYSQL == TRUE)
		save_spamassassin_mysql($username);
	else
		save_spamassassin_file($username);
}


function save_spamassassin_mysql($username)
{
	global $sa;
	global $sac;
	global $sabl;
	global $sawl;

	if (!mysql_connect(SA_DB_HOST,SA_DB_USER,SA_DB_PASS))
		die("mysql_connect: ". mysql_error());
	if (!mysql_select_db(SA_DB_DATABASE))
		die("mysql_select_db: ". mysql_error());

	$mysql = mysql_query("DELETE FROM ". SA_DB_TABLE ." WHERE username='".
		$username ."'");

	$rewrite_header_subject = 1;
	ksort($sa,SORT_STRING);		// Sort SA settings by keys
	reset($sa);
	while (list($token,$value) = each ($sa))
	{

		if ($token == "rewrite_header_subject")
		{
			$rewrite_header_subject = $value;
			continue;
		}
		if ($token == "rewrite_header_subject_tag")
		{
			if (($value != NULL) && ($rewrite_header_subject == 1))
			{
				$token = "rewrite_header";
				$value = "Subject ". $value;
			}
			else continue;
		}

		if (isset($value))
		{
			$mysql = mysql_query("INSERT INTO ". SA_DB_TABLE
				." SET preference='". $token ."',value='".
				mysql_escape_string($value) ."',username='".
				$username ."'");
			if (mysql_errno() != 0) die("query: ". mysql_error() );
		}
	}

	if (count($sawl))
	{
		reset($sawl);
		while (list($value,$token) = each ($sawl))
		{
			if ($token)
			{
			$mysql = mysql_query("INSERT INTO ". SA_DB_TABLE
				." SET preference='whitelist_from',value='".
				mysql_escape_string($value) ."',username='".
				$username ."'");
			}
		}
	}

	if (count($sabl))
	{
		reset($sabl);
		while (list($value,$token) = each ($sabl))
		{
			if ($token)
			{
			$mysql = mysql_query("INSERT INTO ". SA_DB_TABLE
				." SET preference='blacklist_from',value='".
				mysql_escape_string($value) ."',username='".
				$username ."'");
			}
		}
	}

	if (count($sac))
	{
		reset($sac);
		while (list($value,$token) = each ($sac))
		{
			if ($token)
			{
			$mysql = mysql_query("INSERT INTO ". SA_DB_TABLE
				." SET preference='score',value='".
				mysql_escape_string($value) ." ". $token
				."',username='". $username ."'");
			}
		}
	}
	mysql_close();
}


function save_spamassassin_file($username)
{
	global $sa_spamassassin_name;
	global $sa;
	global $sac;
	global $sabl;
	global $sawl;
	$sa_spamassassin_name = "../../data/$username.spamassassin";

	$safp = fopen($sa_spamassassin_name,"w");
	if (!$safp) {
		print "Failed to save preferences<br>";
		return;
	}
	$rewrite_header_subject = 1;
	ksort($sa,SORT_STRING);		// Sort SA settings by keys
	reset($sa);
	while (list($token,$value) = each ($sa)) {
		if ($token == "rewrite_header_subject")
		{
			$rewrite_header_subject = $value;
			continue;
		}
		if ($token == "rewrite_header_subject_tag")
		{
			if (($value != NULL) && ($rewrite_header_subject == 1))
			{
				$token = "rewrite_header";
				$value = "Subject ". $value;
			}
			else continue;
		}

		if (isset($value)) {
			fputs($safp,"$token $value\n");
		}
	}
	if (count($sawl)) {
		reset($sawl);
		while (list($value,$token) = each ($sawl)) {
			if ($token) {
				fputs($safp,"whitelist_from $value\n");
			}
		}
	}
	if (count($sabl)) {
		reset($sabl);
		while (list($value,$token) = each ($sabl)) {
			if ($token) {
				fputs($safp,"blacklist_from $value\n");
			}
		}
	}
	if (count($sac)) {
		reset($sac);
		while (list($value,$token) = each ($sac)) {
			if ($token) {
				fputs($safp,"score $value $token\n");
			}
		}
	}
	fclose($safp);
}


//------------------------------------------------------------------------
/* Initialize the plugin */
function squirrelmail_plugin_init_fg_spamassassin()
{
	global $squirrelmail_plugin_hooks;

	$squirrelmail_plugin_hooks['optpage_register_block']['fg_spamassassin'] =
		'spamassassin_options';
	$squirrelmail_plugin_hooks['read_body_header_right']['fg_spamassassin'] =
		'spamassassin_show_link';
	$squirrelmail_plugin_hooks['menuline']['fg_spamassassin'] =
		'spamassassin_menuline';
}


// Show the link on the read-a-message screen
function spamassassin_show_link()
{
	global $passed_id, $mailbox, $ent_num, $spamassassin_enabled,
		$startMessage, $spamassassin_method, $username, $sa,
		$message;

	if (SA_SHOW_LINK != TRUE) return;

	load_spamassassin($username);

	// This was stolen from printer_friendly
	// Do I really need/want it?
	if (!trim($mailbox))
		$mailbox = 'INBOX';

	if (! $sa["procmail_enabled"]) return;

	$from_name = $message->rfc822_header->from[0]->mailbox .'@'.
		$message->rfc822_header->from[0]->host;
?>
| Sender: 
<a href="../plugins/fg_spamassassin/spamassassin.php?addbl=<?PHP
	echo urlencode($from_name);  ?>&mailbox=<?PHP
	echo urlencode($mailbox);  ?>&startMessage=<?PHP
	echo urlencode($startMessage);  ?>"><?PHP
	echo _("Blacklist");  ?></a> or
<a href="../plugins/fg_spamassassin/spamassassin.php?addwl=<?PHP
	echo urlencode($from_name);  ?>&mailbox=<?PHP
	echo urlencode($mailbox);  ?>&startMessage=<?PHP
	echo urlencode($startMessage);  ?>"><?PHP
	echo _("Whitelist");  ?></a>
<?php
}


// Show the link to our own custom options page
function spamassassin_options()
{
	global $optpage_blocks;

	$optpage_blocks[] = array(
		'name' => "SpamAssassin - Marks Probable Spam",
		'url' => '../plugins/fg_spamassassin/options.php',
		'desc' => "Checks incoming mail and marks it as spam if it is likely spam, using a variety of heuristics.",
		'js' => false );
}

function spamassassin_version()
{
	return( 1.7 );
}


function spamassassin_menuline()
{
	if (SA_HEADER_LINK == TRUE)
	{
		displayInternalLink('plugins/fg_spamassassin/options.php',
			"SpamAssassin");
		print("&nbsp;&nbsp\n");
	}
}

?>